;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux anjsp package
;;
;; Originally contributed by Nils Naumann <naumann@unileoben.ac.at>
;; Modified by Dirk Eddelbuettel <edd@debian.org>
;; Adapted for dh-make by Jim Van Zandt <jrv@vanzandt.mv.com>

;; The anjsp package follows the Debian/GNU Linux 'emacsen' policy and
;; byte-compiles its elisp files for each 'emacs flavor' (emacs19,
;; xemacs19, emacs20, xemacs20...).  The compiled code is then
;; installed in a subdirectory of the respective site-lisp directory.
;; We have to add this to the load-path:
(setq load-path (cons (concat "/usr/share/"
                              (symbol-name flavor)
			      "/site-lisp/anjsp") load-path))

(autoload 'anjsp-mode "anjsp" "ando jsp mode" t)
(setq auto-mode-alist
     (cons (cons "\\.jsp$" 'anjsp-mode) auto-mode-alist))

(autoload 'anphp-mode "anjsp" "ando php mode" t)
(setq auto-mode-alist
     (cons (cons "\\.psp$" 'anphp-mode) auto-mode-alist))

(setq anjsp-base-java-mode 'java-mode)
(setq anjsp-base-html-mode 'html-helper-mode)

